# WOKIT Custom

This plugin contains several adjustments and methods for a smoother content maintenance

## Custom Login Page

All necessary functions for generating a custom login page
- The backend url can be set in the wokit-project .env file (default is /backend)
- :fire: Important: changing the backend url requires to regenerate the permalinks
    - If not accessible from the backend, use:
    - `wp option get permalink_structure` and `wp option update permalink_structure '<result from get>'`
    - If no changes to the permalink structure were made, use: `wp option update permalink_structure '/%postname%'`
    - Last but not least flush the permalinks `wp rewrite flush`
- Direct call to wp-login or wp-admin will be redirected to the front or 404 page


## Includes

- Base functions
- Breadcrumbs :blue_book: blueprint file
- Custom post types :blue_book: blueprint file
- Elementor Custom Widgets
- TinyMCE Custom Options :blue_book: blueprint file

All files from the includes folder are loaded except they have a preceding underscore.\
Just remove the `_` underscore to set the file active.

## Base functions

Overall functions concerning the whole wordpress project
- Allow svg file upload
- Custom login screen for the backend
- Some timeout fixes for curl responses (needs to be tested in an live environment)
- Ancestor classes for multilevel menus
- Page restrictions for non admins


## Elementor Custom Widgets

A list of custom widgets for the Elementor page builder
- Widgets can be turned on/off through the dedicated settings page
- Widgets can be deactivated with a preceding underscore: `_section-xxx.php`
- Each widget can be customized  

## Settings Page

The settings page folder contains settings page customization
- As default only the elementor-custom-settings page is activated
- A blueprint for futher options is included
    - If further setting pages are used they need to be included, use `wokit-custom.php` for that


## TinyMCE Custom Options

They TinyMCE Editor can be modified to include predefined font formats.
 - As this is very specific for each project, the include file is deactivated per default.
 - Just make the necessary adjustment, connect the defined classes with the styles from the theme and use the include file by removing the preceding underscore.