// Custom JS for Elementor Settings Page

function switchWidgetStatus(item) {
  if (item.querySelector('input[type="radio"]:first-of-type').checked == true) {
    item.querySelector('input[type="radio"]:last-of-type').checked = true;
    item.classList.remove('active');
    item.classList.add('inactive');
  } else {
    item.querySelector('input[type="radio"]:first-of-type').checked = true;
    item.classList.remove('inactive');
    item.classList.add('active');
  }
}

function switchSettingStatus(item) {
  if (item.querySelector('input[type="radio"]:first-of-type').checked == true) {
    item.querySelector('input[type="radio"]:last-of-type').checked = true;
    item.classList.remove('show');
    item.classList.add('hide');
    item.querySelector('.status').textContent = 'ausgeblendet';
  } else {
    item.querySelector('input[type="radio"]:first-of-type').checked = true;
    item.classList.remove('hide');
    item.classList.add('show');
    item.querySelector('.status').textContent = 'eingeblendet';
  }
}

var buttonAct, buttonDeact, newTd;

document.querySelectorAll('.widget_section .form-table tr').forEach((elementRow) => {
  newTd = document.createElement("td");

  buttonAct = document.createElement("div");
  buttonAct.className = 'activate-all button-secondary';
  buttonAct.textContent = "Alle aktivieren";

  buttonDeact = document.createElement("div");
  buttonDeact.className = 'deactivate-all button-secondary';
  buttonDeact.textContent = "Alle deaktivieren";

  newTd.appendChild(buttonAct);
  newTd.appendChild(buttonDeact);
  elementRow.appendChild(newTd);

  if (buttonAct) {
    buttonAct.addEventListener('click', function (e) {
      e.target.parentNode.previousElementSibling.querySelectorAll('.widget-item input[type="radio"]:first-of-type').forEach((radiobutton) => {
        radiobutton.checked = true;
        radiobutton.parentNode.classList.remove('inactive');
        radiobutton.parentNode.classList.add('active');
      });
    });
  }

  if (buttonDeact) {
    buttonDeact.addEventListener('click', function (e) {
      e.target.parentNode.previousElementSibling.querySelectorAll('.widget-item input[type="radio"]:last-of-type').forEach((radiobutton) => {
        radiobutton.checked = true;
        radiobutton.parentNode.classList.remove('active');
        radiobutton.parentNode.classList.add('inactive');
      });
    });
  }
});

var widgetItems = document.querySelectorAll('.widget_section .widget-item');
widgetItems.forEach(item => {
  item.addEventListener('click', () => {
    switchWidgetStatus(item);
  });
});

var settingItems = document.querySelectorAll('.settings_section .setting-item');
settingItems.forEach(item => {
  item.addEventListener('click', () => {
    switchSettingStatus(item);
  });
});