<?php

define( 'CPT_PRODUCTS', 'products' );
define( 'CPT_PRODUCTS_PARENT_ID', 13 );

/**
 * Change regular posts to news 
 */ 

function change_post_object() 
{
    $get_post_type = get_post_type_object('post');
    $labels = $get_post_type->labels;
	$labels->name = 'News';
	$labels->singular_name = 'News';
	$labels->add_new = 'News hinzufügen';
	$labels->add_new_item = 'News hinzufügen';
	$labels->edit_item = 'News bearbeiten';
	$labels->new_item = 'News';
	$labels->view_item = 'News ansehen';
	$labels->search_items = 'News suchen';
	$labels->not_found = 'Keine News gefunden';
	$labels->not_found_in_trash = 'Keine News im Papierkorb gefunden';
	$labels->all_items = 'Alle News';
	$labels->menu_name = 'News';
	$labels->name_admin_bar = 'News';
	$get_post_type->menu_icon = 'dashicons-testimonial';
}
add_action( 'init', 'change_post_object' );

/**
 * Add custom post type => products
 */

function add_products() 
{
    $labels = array(
        'name'                => _x( 'Produkte', 'Post Type General Name', 'wokit-custom' ),
        'singular_name'       => _x( 'Produkt', 'Post Type Singular Name', 'wokit-custom' ),
        'menu_name'           => __( 'Produkte', 'wokit-custom' ),
        'parent_item_colon'   => __( 'Elternprodukt:', 'wokit-custom' ),
        'all_items'           => __( 'Alle Produkte', 'wokit-custom' ),
        'view_item'           => __( 'Produkt ansehen', 'wokit-custom' ),
        'add_new_item'        => __( 'Neues Produkt erstellen', 'wokit-custom' ),
        'add_new'             => __( 'Neues Produkt', 'wokit-custom' ),
        'edit_item'           => __( 'Produkt bearbeiten', 'wokit-custom' ),
        'update_item'         => __( 'Produkt updaten', 'wokit-custom' ),
        'search_items'        => __( 'Produtk suchen', 'wokit-custom' ),
        'not_found'           => __( 'Produkt nicht gefunden ', 'wokit-custom' ),
        'not_found_in_trash'  => __( 'Produkt im Papierkorb nicht gefunden', 'wokit-custom' ),
    );
   
    $args = array(
        'label'               => __( 'Produkte', 'wokit-custom' ),
        'description'         => __( 'Bropack Produkte', 'wokit-custom' ),
        'labels'              => $labels,
        'supports'            => array( ),
        // 'taxonomies'          => array( 'product_cat' ),
        'hierarchical'        => false,
        'public'              => true,
        'show_ui'             => true,
        'show_in_rest'        => true,
        'show_in_menu'        => true,
        'show_in_nav_menus'   => true,
        'show_in_admin_bar'   => true,
        'menu_position'       => 5,
        'menu_icon'           => plugins_url() . '/wokit-custom/assets/icons/palette.svg', 
        'can_export'          => true,
        'has_archive'         => false,
        'exclude_from_search' => false,
        'publicly_queryable'  => true,
        'capability_type'     => 'page',
        'query_var'           => true,
        'rewrite'             => array( 'slug' => 'produkte/%parent_pages%', 'with_front' => false ),
    );

    return array(CPT_PRODUCTS, $args);
}

//function add_career() {
//    $labels = array(
//        'name'                => _x( 'Jobs', 'Post Type General Name', 'wokit-custom' ),
//        'singular_name'       => _x( 'Job', 'Post Type Singular Name', 'wokit-custom' ),
//        'menu_name'           => __( 'Jobs', 'wokit-custom' ),
//        'parent_item_colon'   => __( 'Elternjob:', 'wokit-custom' ),
//        'all_items'           => __( 'Alle Jobs', 'wokit-custom' ),
//        'view_item'           => __( 'Job ansehen', 'wokit-custom' ),
//        'add_new_item'        => __( 'Neuen Job erstellen', 'wokit-custom' ),
//        'add_new'             => __( 'Neuer Job', 'wokit-custom' ),
//        'edit_item'           => __( 'Job bearbeiten', 'wokit-custom' ),
//        'update_item'         => __( 'Job updaten', 'wokit-custom' ),
//        'search_items'        => __( 'Job suchen', 'wokit-custom' ),
//        'not_found'           => __( 'Job nicht gefunden', 'wokit-custom' ),
//        'not_found_in_trash'  => __( 'Job im Papierkorb nicht gefunden', 'wokit-custom' ),
//    );
//    $args = array(
//        'label'               => __( 'Job', 'wokit-custom' ),
//        'description'         => __( 'Post Type Description', 'wokit-custom' ),
//        'labels'              => $labels,
//        'supports'            => array( ),
//        'taxonomies'          => array( 'category', 'post_tag' ),
//        'hierarchical'        => false,
//        'public'              => true,
//        'show_ui'             => true,
//        'show_in_menu'        => true,
//        'show_in_nav_menus'   => true,
//        'show_in_admin_bar'   => true,
//        'menu_position'       => 6,
//        'menu_icon'           => 'dashicons-welcome-learn-more',
//        'can_export'          => true,
//        'has_archive'         => true,
//        'exclude_from_search' => false,
//        'publicly_queryable'  => true,
//        'capability_type'     => 'post',
//    );
//
//    return array('Karriere', $args);
//}

/**
 * Register custom post types
 * 
 * Add register_post_type for each additional post type
 */
function custom_post_types() 
{   
    register_post_type( add_products()[0], add_products()[1] );
    //register_post_type( add_career()[0], add_career()[1] );
}
// Hook into the 'init' action
//add_action( 'init', 'custom_post_types', 0 );


/**
 * Handle the '%parent_pages%' url placeholder for CPT_PRODUCTS
 */
function replace_cpt_permalink( $post_link, $post )
{
    if ( is_object( $post ) && $post->post_type == CPT_PRODUCTS ){

        // Get the post meta where the parent (products) page_id is set, if empty replace %parent_pages% with generic url slug
        $meta_id = get_post_meta( $post->ID, '_product_cat_meta_id' , true );
        if( $meta_id == ''){
            return str_replace( '%parent_pages%' , 'nicht-zugewiesen' , $post_link );
        }

        // Go through all ancestors from parent (products) page_id till top page: CPT_PRODUCTS_PARENT_ID
        $parents = [];
        $full_path = '';
        $i = 0;

        do {
            $parents[] = get_post($meta_id)->post_name; 
            $meta_id = get_post_parent($meta_id)->ID;
        } while ($meta_id !== CPT_PRODUCTS_PARENT_ID);

        $parents = array_reverse($parents);

        foreach($parents as $parent) {
            if ($i != 0) {
                $full_path .= '/';
            } 
            
            $full_path .= $parent;           
            $i++;
        }

        // Replace %parent_pages% with the full url to the current post.
        // If the psot has no parent, replace with generic url slug
        if( $parents[0] !== get_post($post->ID)->post_name){
            return str_replace( '%parent_pages%' , $full_path , $post_link );
        } else {
            return str_replace( '%parent_pages%' , 'nicht-zugewiesen' , $post_link );
        }
    }
    return $post_link;
}
add_filter( 'post_type_link', 'replace_cpt_permalink', 1, 2 );

/**
 * Additional rewrite rules are set for matching cpt urls
 * The problem is that the posts can be displayed at different url levels (products meta -> parent_id). 
 * This means that not only one generally valid address (as with the regular posts/news) can be given.
 */
function add_cpt_rewrite_rules( $rules ) 
{
    $new = array();
    $posts = get_posts([
        'post_type' => CPT_PRODUCTS,
        'post_status' => 'publish',
        'numberposts' => -1 // Set to -1 to include all posts
        // 'order'    => 'ASC'
    ]);

    foreach($posts as $post) {
        $meta_id = get_post_meta( $post->ID, '_product_cat_meta_id' , true );
        
        if (!empty($meta_id) && $meta_id !== '0') {
            $parents = [];
            $full_path = '';
            $i = 0;
    
            do {
                $parents[] = get_post($meta_id)->post_name; 
                $meta_id = get_post_parent($meta_id)->ID;
            } while ($meta_id !== CPT_PRODUCTS_PARENT_ID);
    
            $parents = array_reverse($parents);
    
            foreach($parents as $parent) {
                if ($i != 0) {
                    $full_path .= '\/';
                } 
                
                $full_path .= $parent;           
                $i++;
            }

            $new['produkte\/'.$full_path.'\/('.$post->post_name.')(?=[\/]*\/?$)'] = 'index.php?products=$matches[1]';            
        } else {
            $new['produkte\/nicht-zugewiesen\/('.$post->post_name.')(?=[\/]*\/?$)'] = 'index.php?products=$matches[1]';
        }        
    }    

  return array_merge( $new , $rules ); // Ensure our rules come first
}
add_filter( 'rewrite_rules_array', 'add_cpt_rewrite_rules' );


/**
 * get all children pages from $parent_id
 */
function get_children_by_parent($parent_id) 
{
    $children = array();
    //$wp_query = new WP_Query();
    //$all_wp_pages = $wp_query->query(array('post_type' => 'page'));    
    $child_args = array(
        'numberposts' => -1,
        'post_parent' => $parent_id, // The parent id.
        'post_type'   => 'page',
        'post_status' => 'publish'
    );
    $posts = get_posts( $child_args );

    foreach( $posts as $child ){
        // recursion!! hurrah
		//var_dump($child);
		array_push($children, $child);
        $gchildren = get_children_by_parent($child->ID);
        // merge the grand children into the children array
        if( !empty($gchildren) ) {
            $children = array_merge($children, $gchildren);
        }
    }
    return $children;
}


/**
 * Add custom meta boxes to save parent page id's in post meta
 */
function add_custom_meta_box_to_cpt() 
{
    // Limit the meta boxes to post_types
    $post_type = [ CPT_PRODUCTS ];
    foreach ( $post_type as $type ) {
        add_meta_box(
            'product_cat_id',
            'Produktkategorie',
            'product_cat_custom_box_html',
            $type,
            'side',
            'high'
        );
    }
}
add_action( 'add_meta_boxes', 'add_custom_meta_box_to_cpt' );


/**
 * Callback function for the cpt_meta_boxes
 */
function product_cat_custom_box_html( $post ) 
{
    $children = get_children_by_parent(CPT_PRODUCTS_PARENT_ID);
    $value = get_post_meta( $post->ID, '_product_cat_meta_id', true );

    ?>
    <label for="wporg_field">Bitte wählen Sie die Produktkategorie aus:</label>
    <select name="wporg_field" id="wporg_field" class="components-select-control__input">
        <option value="">Produkte</option>
        <?php 
            
            foreach($children as $child) {
                if ($child->post_parent == CPT_PRODUCTS_PARENT_ID) {
                    echo '<option value="' . $child->ID . '" ' . selected( $value, $child->ID ) . '>' . $child->post_title . '</option>';
                } else {
                    echo '<option value="' . $child->ID . '" ' . selected( $value, $child->ID ) . '>'.str_repeat("-",count(get_post_ancestors($child->ID)) - 1).' ' . $child->post_title . '</option>';
                }                
            }   
        ?>
    </select>
    <style>
        .edit-post-meta-boxes-area__container, .edit-post-meta-boxes-area .inside {
            box-sizing: inherit;
        }

        label[for="wporg_field"] {
            margin-bottom: 10px;
            display: block;
        }

        .edit-post-meta-boxes-area #poststuff .postbox-header h2.hndle.ui-sortable-handle, 
        #wporg_field {
            font-size: 13px;
        }
    </style>
    <?php
}


/**
 * On save_post set the post page as parent for regular posts (news)
 * For cpt products get the post meta and use the manual set value as parent
 */
function set_post_parent_on_save($post_id) 
{
    // If this is just a revision, don't do anything
    if ( wp_is_post_revision( $post_id ) )
        return;

    /**
     * Save meta data on save_post
     * If user is in classic or gutenberg edit mode, the key wporg_field exists otherwise the user will be in elementor editor
     * 
     * In elementor editor we are getting the value from the settings_panel
     */

    if ( array_key_exists( 'wporg_field', $_POST ) ) {
        $meta_value = $_POST['wporg_field'];
    } else {
        $page_settings_manager = \Elementor\Core\Settings\Manager::get_settings_managers( 'page' );

        // Get the settings model for current post
        $page_settings_model = $page_settings_manager->get_model( $post_id );

        // Retrieve the color we added before
        $meta_value = $page_settings_model->get_settings( '_elem_product_cat_meta_id' );
    }

    // Update post meta with the meta_value
    // Update post meta with elementor setting
    update_post_meta(
        $post_id,
        '_product_cat_meta_id',
        $meta_value 
    );

    update_post_meta( 
        $post_id, 
        '_elementor_page_settings', 
        array('_elem_product_cat_meta_id' => $meta_value) 
    );

	$page_for_posts = get_option( 'page_for_posts' );
    // Check if it is a post
    if ( 'post' == get_post_type( $post_id ) ) {
        // unhook this function so it doesn't loop infinitely
        remove_action( 'save_post', 'set_post_parent_on_save' );

        // update the post, which calls save_post again
        wp_update_post(array(
            'ID' => $post_id,
            'post_parent' => $page_for_posts
        ));

        // re-hook this function
        add_action( 'save_post', 'set_post_parent_on_save' );
    } else if ( 'products' == get_post_type( $post_id )) {
		remove_action( 'save_post', 'set_post_parent_on_save' );
		$value = get_post_meta( $post_id, '_product_cat_meta_id', true );	

		wp_update_post(array(
			'ID' => $post_id,
			'post_parent' => $value
		));

        // Be very carefull as Flush_rewrite_rules() is very ressource consuming but will be fired only when a custom post of type 'products' will be saved
        // Don't call it without any restrictions
        Flush_rewrite_rules();
		add_action( 'save_post', 'set_post_parent_on_save' );
	}
}
add_action( 'save_post', 'set_post_parent_on_save' );


/**
 * Add select field to cpt products settings in elementor
 */
function add_elementor_page_settings_controls( \Elementor\Core\DocumentTypes\Post $post ) 
{
	$post_id = get_the_ID();
	$value = get_post_meta( $post_id, '_product_cat_meta_id', true );

	$meta_array = [];
    $children = get_children_by_parent(CPT_PRODUCTS_PARENT_ID);

	foreach($children as $child) {
		if ($child->post_parent == CPT_PRODUCTS_PARENT_ID) {
			$meta_array += [
				$child->ID => __( $child->post_title, 'elementor-custom-widgets'),
			];
		} else {
			$meta_array += [
				$child->ID => __( '- ' . $child->post_title, 'elementor-custom-widgets'),
			];
		}		
	}   	

	if (get_post_type($post_id) == 'products') {
		$post->add_control(
			'_elem_product_cat_meta_id',
			[
				'label' => __( 'Produktkategorie', 'elementor-custom-widgets' ),
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' =>  $value,
				'options' => $meta_array,
			]
		);
	}
}
add_action( 'elementor/element/wp-post/document_settings/after_section_start', 'add_elementor_page_settings_controls' );


/**
 * Add custom column to cpt 'products'
 */
function add_custom_column_for_cpt($columns) {
    $columns['product_cat'] = 'Produktkategorie';
    return $columns;
}
add_filter( 'manage_products_posts_columns', 'add_custom_column_for_cpt' );

/**
 * Insert data to custom column for cpt 'products'
 */
function insert_data_into_cpt_column( $column, $post_id ) {
    $meta_id = get_post_meta( $post_id , '_product_cat_meta_id' , true );
    $parents = [];
    switch ( $column ) {
        case 'product_cat' :

            if ($meta_id !== '') {                    
                do {
                    $parents[] = [
                        $meta_id => get_the_title($meta_id)
                    ]; 
                    $meta_id = get_post_parent($meta_id)->ID;
                } while ($meta_id !== CPT_PRODUCTS_PARENT_ID);

                $i = 0;
                foreach(array_reverse($parents) as $parent) {
                    foreach($parent as $key => $value) {
                        if ($i == 0) {
                            echo '<span data-id="' . $key . '">' . $value . '</span>';
                        } else {
                            echo '<br>- <span data-id="' . $key . '">' . $value . '</span>';
                        }
                    }
                    $i++; 
                }                
            } else {
                echo '-';
            }                    

            break;
        default:
            break;
    }
}
add_action( 'manage_products_posts_custom_column' , 'insert_data_into_cpt_column', 10, 2 );


/**
 * Add custom fields to the quick edit box 
 * quick_edit_custom_box allows to add HTML in Quick Edit
 */
function add_cpt_to_quick_edit($column_name, $post_type)
{
    $children = get_children_by_parent(CPT_PRODUCTS_PARENT_ID);

    if (!($column_name === 'product_cat')) return;

    switch ($column_name) {
        case 'product_cat':

            echo '<fieldset class="inline-edit-col-right" style="border: 1px solid #dddddd;">
                    <div class="inline-edit-col">';

            // # note that, wp_nonce_field() must add it here at the first custom column. DO NOT add outside the switch().
            // Otherwise wp_nonce_field() will render every time that quick_edit_custom_box action hook is called for each column.
            wp_nonce_field('wpar_q_edit_nonce');
            echo '<label for="wporg_field">Bitte wählen Sie die Produktkategorie aus:</label>
                    <select name="wporg_field" id="wporg_field" class="components-select-control__input">
                        <option value="">Produktkategorie wählen</option>';
                        foreach($children as $child) {
                            if ($child->post_parent == CPT_PRODUCTS_PARENT_ID) {
                                echo '<option value="' . $child->ID . '">' . $child->post_title . '</option>';
                            } else {
                                echo '<option value="' . $child->ID . '">-'.str_repeat("-",count(get_post_ancestors($child->ID)) - 2).' ' . $child->post_title . '</option>';
                            }
                        } 
                    echo '</select>';
            echo '<br><br>';
            // # a last column then print out the end tags of fieldset here.      
            echo '</div></fieldset>';
            break;
        default:
            break;
    }
}
add_action('quick_edit_custom_box',  'add_cpt_to_quick_edit', 10, 2);


/**
 * Save the custom field value from the quick edit box 
 */
function cpt_quick_edit_save($post_id)
{
    // If it is autosave, we don't do anything.
    if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE)
        return $post_id;

    // check user capabilities
    if (!current_user_can('edit_post', $post_id)) {
        return;
    }

    // check nonce
    //if (!wp_verify_nonce($_POST['_wpnonce'], 'wpar_q_edit_nonce')) {
    //    return;
    //}

    // update the post meta values of current post
    if (isset($_POST['product_cat'])) {
        $meta_value = $_POST['wporg_field'];

        update_post_meta(
            $post_id,
            '_product_cat_meta_id',
            $meta_value 
        );
    
        update_post_meta( 
            $post_id, 
            '_elementor_page_settings', 
            array('_elem_product_cat_meta_id' => $meta_value) 
        );
    }
}
add_action('save_post_products', 'cpt_quick_edit_save');


/**
 * Populate the custom field values at the quick edit box using Javascript
 */
function cpt_quick_edit_js()
{
        // # check the current screen
        // https://developer.wordpress.org/reference/functions/get_current_screen/
        $current_screen = get_current_screen();

        if ($current_screen->id != 'edit-products' || $current_screen->post_type !== 'products')
            return;

        // # Make sure jQuery library is loaded because we will use jQuery for populate our custom field value.
        wp_enqueue_script('jquery');
        ?>

        <!-- add JS script -->
        <script type="text/javascript">
            jQuery(function($) {

                // we create a copy of the WP inline edit post function
                var $wpar_inline_editor = inlineEditPost.edit;

                // Note: Hooking inlineEditPost.edit must be done in a JS script, loaded after wp-admin/js/inline-edit-post.js
                // then we overwrite the inlineEditPost.edit function with our own code
                inlineEditPost.edit = function(id) {

                    // call the original WP edit function 
                    $wpar_inline_editor.apply(this, arguments);


                    // ### start: add our custom functionality below  ###

                    // get the post ID
                    var $post_id = 0;
                    if (typeof(id) == 'object') {
                        $post_id = parseInt(this.getId(id));
                    }

                    // if we have our post
                    if ($post_id != 0) {
                        // tips: use the inspecttion tool to help you see the HTML structure on the edit page.

                        // explanation: 
                        // On the posts management page, all posts will render inside the <tbody> along with "the-list" id.
                        // Then each post will render on each <tr> along with "post-176" which 176 is my post ID. Your will be difference.
                        // When the quick edit menu is clicked on the "post-176", the <tr> will be set as hide(display:none)
                        // and the new <tr> along with "edit-176" id will be appended after <tr> which is hidden.
                        // What we will do, we will use the jQuery to find the website value from the hidden <tr>. 
                        // Get that value and assign to the website input field on the quick edit box.
                        // 
                        // The concept is the same when you create the inline editor by jQuery manually.

                        // define the edit row
                        var $edit_row = $('#edit-' + $post_id);
                        var $post_row = $('#post-' + $post_id);

                        // get the data
                        var $results = $('.column-product_cat', $post_row).text();
                        var quick = $('.column-product_cat', $post_row).html().split('<br>');

                        var current_product_cat_id = $('.column-product_cat span:last-child', $post_row).attr('data-id');
                        $('select#wporg_field').val(current_product_cat_id);
                    }
                }
            });
        </script>
    <?php
}
//https://applerinquest.com/how-to-add-custom-fields-to-quick-edit-in-wordpress/
add_action('admin_print_footer_scripts-edit.php', 'cpt_quick_edit_js');