<?php

/**
 * Plugin Name: Wokit Custom
 * Description: Custom settings and modifications
 * Plugin URI:  https://www.zwei14.de
 * Version:     1.0.0
 * Author:      zwei14 GmbH
 * Author URI:  https://www.zwei14.de
 * Text Domain: wokit-custom
 * Domain Path: /languages
 */

if (!defined('ABSPATH')) {
	exit; // Exit if accessed directly.
}

define( 'WOKIT_PLUGIN', __FILE__ );
define( 'WOKIT_PLUGIN_BASENAME', plugin_basename( WOKIT_PLUGIN ) );
define( 'WOKIT_PLUGIN_NAME', trim( dirname( WOKIT_PLUGIN_BASENAME ), '/' ) );
define( 'WOKIT_PLUGIN_DIR', untrailingslashit( dirname( WOKIT_PLUGIN ) ) );
define( 'WOKIT_PLUGIN_URL', plugin_dir_url(__FILE__));
define( 'WOKIT_BACKEND_URL', 'backend' );

/**
 * Load language files before including the other php files
 */
function plugin_load_textdomain() 
{
    load_plugin_textdomain( 'wokit-custom', false, basename( dirname( __FILE__ ) ) . '/languages/' );
}
add_action( 'init', 'plugin_load_textdomain' );

function load_includes()
{
    $includes = WOKIT_PLUGIN_DIR . '/includes';
    $includes = array_values(preg_grep('/^((?!\/_).)*.php$/', glob($includes . '/*.*')));

    foreach ($includes as $key => $item) {
        require_once($item);
    }
}
load_includes();